'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

exports.__esModule = true
exports.default = Emoji

var _extends2 = _interopRequireDefault(
  require('@babel/runtime/helpers/extends')
)

var _objectWithoutProperties2 = _interopRequireDefault(
  require('@babel/runtime/helpers/objectWithoutProperties')
)

var _react = _interopRequireDefault(require('react'))

var _isChrome = _interopRequireDefault(require('./utils/isChrome'))

var _toImage = _interopRequireDefault(require('./utils/toImage'))

const defaultImgStyle = {
  contain: 'strict',
  verticalAlign: 'text-bottom',
  imageRendering:
    _isChrome.default === true ? '-webkit-optimize-contrast' : 'crisp-edges',
}

function Emoji(_ref) {
  let {emoji, codePoint, style, options} = _ref,
    props = (0, _objectWithoutProperties2.default)(_ref, [
      'emoji',
      'codePoint',
      'style',
      'options',
    ])
  props.width = options.size
  props.height = options.size
  props.style =
    style === void 0
      ? defaultImgStyle
      : (0, _extends2.default)({}, defaultImgStyle, style)
  props.src = (0, _toImage.default)(codePoint, options)
  props.alt = emoji
  return _react.default.createElement('img', props)
}

if (process.env.NODE_ENV !== 'production') {
  const PropTypes = require('prop-types')

  Emoji.propTypes = {
    emoji: PropTypes.string.isRequired,
    codePoint: PropTypes.string.isRequired,
    style: PropTypes.object,
    options: PropTypes.shape({
      size: PropTypes.number,
      hiDpi: PropTypes.bool,
      publicPath: PropTypes.string,
      extension: PropTypes.string,
    }).isRequired,
  }
}
