'use strict'

exports.__esModule = true
exports.default = void 0
const cache = {}

var _default = uc => {
  if (cache[uc] === void 0) {
    const chars = Array.from(uc)
    const codePoints = []

    for (let i = 0; i < chars.length; i++) {
      const char = chars[i]
      const codePoint = char.codePointAt(0) // ignores empty joiners (0x200D) and variation selectors (0xFE0F)

      if (codePoint !== 0x200d && codePoint !== 0xfe0f) {
        codePoints.push(codePoint.toString(16).padStart(4, '0'))
      }
    }

    cache[uc] = codePoints.join('-')
  }

  return cache[uc]
}

exports.default = _default
