import _extends from '@babel/runtime/helpers/extends'
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties'
import React from 'react'
import isChrome from './utils/isChrome'
import toImage from './utils/toImage'
const defaultImgStyle = {
  contain: 'strict',
  verticalAlign: 'text-bottom',
  imageRendering:
    isChrome === true ? '-webkit-optimize-contrast' : 'crisp-edges',
}
export default function Emoji(_ref) {
  let {emoji, codePoint, style, options} = _ref,
    props = _objectWithoutProperties(_ref, [
      'emoji',
      'codePoint',
      'style',
      'options',
    ])

  props.width = options.size
  props.height = options.size
  props.style =
    style === void 0 ? defaultImgStyle : _extends({}, defaultImgStyle, style)
  props.src = toImage(codePoint, options)
  props.alt = emoji
  return React.createElement('img', props)
}

if (process.env.NODE_ENV !== 'production') {
  const PropTypes = require('prop-types')

  Emoji.propTypes = {
    emoji: PropTypes.string.isRequired,
    codePoint: PropTypes.string.isRequired,
    style: PropTypes.object,
    options: PropTypes.shape({
      size: PropTypes.number,
      hiDpi: PropTypes.bool,
      publicPath: PropTypes.string,
      extension: PropTypes.string,
    }).isRequired,
  }
}
