import _extends from '@babel/runtime/helpers/extends'
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties'
import React from 'react'
import Emoji from './Emoji'
import toSprite from './utils/toSprite'

const EmojiSprite = _ref => {
  let {emoji, codePoint, style, options} = _ref,
    props = _objectWithoutProperties(_ref, [
      'emoji',
      'codePoint',
      'style',
      'options',
    ])

  props.role = 'img'
  props['aria-label'] = emoji
  props.children = emoji
  props.style = _extends(toSprite(codePoint, options), style)
  return React.createElement('span', props)
}

if (process.env.NODE_ENV !== 'production') {
  EmojiSprite.propTypes =
    /* remove-proptypes*/
    Emoji.propTypes
}

export default EmojiSprite
